Package org.eclipse.birt.report.engine.api

# Interface IReportDocument

All Superinterfaces:
  `IDocument`

public interface IReportDocument extends IDocument
A report document (i.e., not modifiable) that can be rendered to other formats in the BIRT presentation engine This is the high-level report document interface.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`GLOBAL_VARIABLE_OPTION_ALL`
`static final int`
`GLOBAL_VARIABLE_OPTION_JAVA_ONLY`
`static final int`
`GLOBAL_VARIABLE_OPTION_JS_ONLY`

## Method Summary

Modifier and Type
Method
Description
`TOCNode`
`findTOC(String tocNodeId)`
Deprecated.
Invoke following code instead: ``
`List`
`findTOCByName(String tocName)`
Deprecated.
Invoke following code instead: ``
`org.eclipse.birt.core.archive.IDocArchiveReader`
`getArchive()`
`InstanceID`
`getBookmarkInstance(String bookmark)`
Return the instance id of report item with the specified bookmark
`long`
`getBookmarkOffset(String bookmark)`
Given a report item bookmark, returns the offset of the report content (to support Reportlet).
`List`
`getBookmarks()`
`List`
`getChildren(String tocNodeId)`
Deprecated.
Invoke following code instead: ``
`InputStream`
`getDesignStream()`
`List<String>`
`getDocumentErrors()`
return the errors in the document.
`IReportRunnable`
`getDocumentRunnable()`
The report runnable is used to create the report document while writing.
`Map`
`getGlobalVariables(String option)`
Deprecated.
`long`
`getInstanceOffset(InstanceID iid)`
Given a report item instance id, returns the offset of the report content (to support Reportlet).
`long`
`getPageCount()`
`long`
`getPageNumber(String bookmark)`
Given a bookmark in a report, find the (first) page that the bookmark appears in (for hyperlinks to a bookmark)
`long`
`getPageNumber(InstanceID iid)`
Given a report item instance idD, returns the page number that the instance starts on (to support Reportlet).
`Map`
`getParameterDisplayTexts()`
returns display texts for all the parameters that are used for generating the current report document.
`Map`
`getParameterValues()`
Deprecated.
Invoke RenderTask.getParameterValues( ) instead.
`IReportRunnable`
`getPreparedRunnable()`
The report runnable is used to create the report document while writing.
`String`
`getProperty(String key)`
Get report document property.
`org.eclipse.birt.report.model.api.ReportDesignHandle`
`getReportDesign()`
`IReportRunnable`
`getReportRunnable()`
The report runnable is used to create the report document while writing.
`String`
`getSystemId()`
return the system id assigned to the document
`ITOCTree`
`getTOCTree(String format, com.ibm.icu.util.ULocale locale)`
Deprecated.
Invoke following code instead: ``
`ITOCTree`
`getTOCTree(String format, com.ibm.icu.util.ULocale locale, com.ibm.icu.util.TimeZone timeZone)`
Deprecated.
Invoke following code instead: ``
`String`
`getVersion()`
Get report document version.
`boolean`
`isComplete()`
`void`
`refresh()`
check the current readed checkpoint and the current writed check point.

### Methods inherited from interface org.eclipse.birt.report.engine.api.IDocument

`close, getName`

## Field Details

### GLOBAL_VARIABLE_OPTION_ALL

static final int GLOBAL_VARIABLE_OPTION_ALL

See Also:
  - Constant Field Values

### GLOBAL_VARIABLE_OPTION_JAVA_ONLY

static final int GLOBAL_VARIABLE_OPTION_JAVA_ONLY

See Also:
  - Constant Field Values

### GLOBAL_VARIABLE_OPTION_JS_ONLY

static final int GLOBAL_VARIABLE_OPTION_JS_ONLY

See Also:
  - Constant Field Values

## Method Details

### getArchive

org.eclipse.birt.core.archive.IDocArchiveReader getArchive()

### getVersion

String getVersion()
Get report document version.

Returns:
  version

### getProperty

String getProperty(String key)
Get report document property.

Parameters:
  `key` -
Returns:
  property

### getDesignStream

InputStream getDesignStream()

Returns:
  a report design stream. This is useful for rerunning a report based on report document

### getReportDesign

org.eclipse.birt.report.model.api.ReportDesignHandle getReportDesign()

Returns:
  the report design handle. user always get a new instance from this interface.

### getReportRunnable

IReportRunnable getReportRunnable()
The report runnable is used to create the report document while writing. If the report document is open with, the report runnable is used to render or extract data from the report document. user always get a new instance from this interface.

Returns:
  the runnable report design. It is available because a report document must be run with a report design

### getPreparedRunnable

IReportRunnable getPreparedRunnable()
The report runnable is used to create the report document while writing. If the report document is open with, the report runnable is used to render or extract data from the report document. user always get a new instance from this interface.

Returns:
  the prepared runnable report design. It is available because a report document must be run with a report design

### getDocumentRunnable

IReportRunnable getDocumentRunnable()
The report runnable is used to create the report document while writing. If the report document is open with, the report runnable is used to render or extract data from the report document. The internal instance is returned and user should not modify it.

Returns:
  the prepared runnable report design. It is available because a report document must be run with a report design

### getParameterValues

@Deprecated Map getParameterValues()
Deprecated.
Invoke RenderTask.getParameterValues( ) instead.
returns values for all the parameters that are used for generating the current report document. Useful for running the report again based on a report document

Returns:
  parameter name/value pairs for generating the current report document.

### getParameterDisplayTexts

Map getParameterDisplayTexts()
returns display texts for all the parameters that are used for generating the current report document. Useful for running the report again based on a report document

Returns:
  parameter name/display text pairs for generating the current report document.

### getPageCount

long getPageCount()

Returns:
  the page count in the report. Used for supporting page-based viewing

### getPageNumber

long getPageNumber(InstanceID iid)
Given a report item instance idD, returns the page number that the instance starts on (to support Reportlet).

Parameters:
  `iid` - report item instance id
Returns:
  the page number that the instance appears first

### getInstanceOffset

long getInstanceOffset(InstanceID iid)
Given a report item instance id, returns the offset of the report content (to support Reportlet).

Parameters:
  `iid` - report item instance id
Returns:
  the offset in the content stream

### getBookmarkOffset

long getBookmarkOffset(String bookmark)
Given a report item bookmark, returns the offset of the report content (to support Reportlet).

Parameters:
  `bookmark` - bookmark of the report item.
Returns:
  the offset in the content stream

### getPageNumber

long getPageNumber(String bookmark)
Given a bookmark in a report, find the (first) page that the bookmark appears in (for hyperlinks to a bookmark)

Parameters:
  `bookmarkName` - bookmark name
Returns:
  the page number that the instance appears first

### getBookmarks

List getBookmarks()

Returns:
  a list of bookmark strings

### getChildren

@Deprecated List getChildren(String tocNodeId)
Deprecated.
Invoke following code instead: `

         IReportDocument document = ...
         RenderTask renderTask = engine.createRenderTask( document );
         ITOCTree tocTree = renderTask.getTOCTree( );
         TOCNode node = tocTree.findTOC(tocNodeId);
         List result = node.getChildren( );

`

Parameters:
  `tocNodeId` - the id of the parent TOC node. Pass null as the root TOC node
Returns:
  A list of TOC nodes thata re direct child of the parent node

### findTOC

@Deprecated TOCNode findTOC(String tocNodeId)
Deprecated.
Invoke following code instead: `

         IReportDocument document = ...
         RenderTask renderTask = engine.createRenderTask( document );
         ITOCTree tocTree = renderTask.getTOCTree( );
         TOCNode result = tocTree.findTOC(tocNodeId);

`
get the TOCNode have the id.

Parameters:
  `tocNodeId` - the id of the toc.
Returns:
  TOCNode with such an Id. NULL if not founded.

### findTOCByName

@Deprecated List findTOCByName(String tocName)
Deprecated.
Invoke following code instead: `

         IReportDocument document = ...
         RenderTask renderTask = engine.createRenderTask( document );
         ITOCTree tocTree = renderTask.getTOCTree( );
         List result = tocTree.findTOCByValue(tocName);

`
Gets the TOCNodes with the given name.

Parameters:
  `tocName` - the name of the toc.
Returns:
  List of all tocs with the specified name.

### getGlobalVariables

@Deprecated Map getGlobalVariables(String option)
Deprecated.

Returns:
  a map for all the global variables defined in JavaScript or Java

### isComplete

boolean isComplete()

Returns:
  whether the document has all been written.

### refresh

void refresh()
check the current readed checkpoint and the current writed check point. if equal, do nothing. otherwise, reload the core stream, the checkpoint and page count.

### getTOCTree

@Deprecated ITOCTree getTOCTree(String format, com.ibm.icu.util.ULocale locale)
Deprecated.
Invoke following code instead: `

         IReportDocument document = ...
         RenderTask renderTask = engine.createRenderTask( document );
         ITOCTree tocTree = renderTask.getTOCTree( );
         ITOCTree result = new TOCView( tocTree.getRoot( ), document.getReportDesgin( ), locale,
                                 TimeZone.getDefault( ), format );

`
Get the TOC tree

Parameters:
  `format` - the format to generate the report
  `locale` - the locale information to generate the report

### getTOCTree

@Deprecated ITOCTree getTOCTree(String format, com.ibm.icu.util.ULocale locale, com.ibm.icu.util.TimeZone timeZone)
Deprecated.
Invoke following code instead: `

         IReportDocument document = ...
         RenderTask renderTask = engine.createRenderTask( document );
         ITOCTree tocTree = renderTask.getTOCTree( );
         ITOCTree result = new TOCView( tocTree.getRoot( ), document.getReportDesgin( ), locale,
                                 timeZone, format );

`
Get the TOC tree

Parameters:
  `format` - the format to generate the report
  `locale` - the locale information to generate the report
  `timeZone` - the time zone information to generate the report

### getBookmarkInstance

InstanceID getBookmarkInstance(String bookmark)
Return the instance id of report item with the specified bookmark

Parameters:
  `bookmark` - the bookmark of the report item
Returns:
  the instance id of the report item

### getSystemId

String getSystemId()
return the system id assigned to the document

Returns:
  the system id

### getDocumentErrors

List<String> getDocumentErrors()
return the errors in the document. The errors are recorded during document generation phase.

Returns:
  the error list.